package org.beangle.webapp.avatar.service;

import java.io.File;
import java.util.Set;

import org.beangle.webapp.avatar.Avatar;
import org.beangle.commons.collection.page.Page;
import org.beangle.commons.collection.page.PageLimit;

/**
 * 照片库
 * 
 * @author chaostone
 * 
 */
public interface AvatarBase {

	public String getDescription();
	
	public Page<String> getAvatarNames(PageLimit pageLimit);

	public Avatar getAvatar(String name);

	public Avatar getDefaultAvatar();

	public Set<String> getTypes();

	boolean containType(String type);

	public boolean isReadOnly();

	public boolean updateAvatar(String name, File file, String type);

	public int updateAvatarBatch(File zipFile);
}
