package org.beangle.webapp.avatar.service;

import java.io.File;
import java.util.List;
import java.util.Set;

import org.beangle.webapp.avatar.Avatar;
import org.beangle.webapp.avatar.service.AvatarBase;
import org.beangle.commons.collection.ListUtil;
import org.beangle.commons.collection.page.Page;
import org.beangle.commons.collection.page.PageLimit;
import org.beangle.commons.collection.page.Pages;

/**
 * 组合头像库
 * 
 * @author chaostone
 * 
 */
public class AvatarBaseGroup implements AvatarBase {

	private List<AvatarBase> bases = ListUtil.newArrayList();

	public boolean containType(String type) {
		boolean contains = false;
		for (AvatarBase base : bases) {
			if (base.containType(type)) {
				contains = true;
				break;
			}
		}
		return contains;
	}

	public Avatar getAvatar(String name) {
		Avatar avatar = null;
		for (AvatarBase base : bases) {
			avatar = base.getAvatar(name);
			if (null != avatar) {
				break;
			}
		}
		return avatar;
	}

	public Page<String> getAvatarNames(PageLimit pageLimit) {
		return Pages.emptyPage();
	}

	public Avatar getDefaultAvatar() {
		return null;
	}

	public String getDescription() {
		return "CompositeAvatarBase";
	}

	public Set<String> getTypes() {
		return null;
	}

	public boolean updateAvatar(String name, File file, String type) {
		return false;
	}

	public int updateAvatarBatch(File zipFile) {
		return 0;
	}

	public boolean isReadOnly() {
		return true;
	}

}
