package org.beangle.webapp.config.service;

import java.util.List;
import java.util.Properties;

import org.beangle.commons.config.property.ConfigProvider;
import org.beangle.model.Entity;
import org.beangle.model.persist.EntityDao;
import org.beangle.webapp.config.model.PropertyConfig;

public class PropertyConfigProvider implements ConfigProvider {

	private EntityDao entityDao;

	public void setEntityDao(EntityDao entityDao) throws ClassNotFoundException {
		this.entityDao = entityDao;
	}

	public Properties getConfig() {
		Properties props = new Properties();
		List<PropertyConfig> rs = entityDao.loadAll(PropertyConfig.class);
		for (final PropertyConfig prop : rs) {
			Class<?> itemClass = null;
			try {
				itemClass = Class.forName(prop.getType());
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
			}
			Object value = prop.getValue();
			if (null != itemClass && Entity.class.isAssignableFrom(itemClass)) {
				value = entityDao.get(itemClass, Long.valueOf(value.toString()));
			}
			props.put(prop.getName(), value);
		}
		return props;
	}
}
