package org.beangle.webapp.security.action;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.StringUtils;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.beangle.security.monitor.AuthenticationException;
import org.beangle.security.monitor.SecurityManager;
import org.beangle.security.monitor.auth.provider.UserNamePasswordAuthentication;
import org.beangle.security.monitor.auth.web.WebUserDetailsSource;
import org.beangle.struts2.action.BaseAction;
import org.beangle.struts2.convention.route.Action;

public class LoginAction extends BaseAction implements ServletRequestAware {

	private SecurityManager securityManager;

	private HttpServletRequest request;

	private String name;

	private String password;

	public String index() {
		if (!shouldLogin()) {
			return "login";
		}
		String errorMsg = doLogin();
		if (StringUtils.isNotEmpty(errorMsg)) {
			addActionError(getText(errorMsg));
			return "login";
		}		
		return redirect(new Action(DashboardAction.class, "index"), "info.action.success");
	}

	protected boolean shouldLogin() {
		name = get("name");
		password = get("password");
		return !(null == name || null == password);
	}

	protected String doLogin() {
		UserNamePasswordAuthentication auth = new UserNamePasswordAuthentication(name.trim(),
				password);
		auth.setRequest(request);
		auth.setDetails(new WebUserDetailsSource().buildDetails(request));
		try {
			securityManager.authenticate(auth);
		} catch (AuthenticationException e) {
			return e.getMessage();
		}
		return "";
	}

	public void setSecurityManager(SecurityManager securityManager) {
		this.securityManager = securityManager;
	}

	public void setServletRequest(HttpServletRequest request) {
		this.request = request;
	}

}
