package org.beangle.webapp.security.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts2.dispatcher.SessionMap;
import org.apache.struts2.interceptor.ServletRequestAware;
import org.apache.struts2.interceptor.ServletResponseAware;
import org.beangle.webapp.security.SecurityActionSupport;
import org.beangle.security.monitor.Authentication;
import org.beangle.security.monitor.SecurityManager;
import org.beangle.struts2.convention.route.Action;
import org.beangle.struts2.util.CookieUtils;

import com.opensymphony.xwork2.ActionContext;

/**
 * @author chaostone
 */
public class LogoutAction extends SecurityActionSupport implements ServletRequestAware,
		ServletResponseAware {

	private HttpServletRequest request;

	private HttpServletResponse response;

	private SecurityManager securityManager;

	public String index() {
		CookieUtils.deleteCookieByName(request, response, Authentication.PASSWORD);
		securityManager.logout(request.getSession());
		((SessionMap<?, ?>) ActionContext.getContext().getSession()).invalidate();
		return redirect(new Action(DashboardAction.class, "index"), "");
	}

	public void setServletResponse(HttpServletResponse response) {
		this.response = response;
	}

	public void setServletRequest(HttpServletRequest request) {
		this.request = request;
	}

	public void setSecurityManager(SecurityManager securityManager) {
		this.securityManager = securityManager;
	}

}
