package org.beangle.webapp.security.action;

import org.beangle.webapp.security.SecurityActionSupport;
import org.beangle.commons.collection.Order;
import org.beangle.commons.collection.page.PageLimit;
import org.beangle.model.query.builder.OqlBuilder;
import org.beangle.security.monitor.SessionController;
import org.beangle.security.monitor.auth.session.SessionActivity;

public class MyActivityAction extends SecurityActionSupport {

	private SessionController sessionController;

	public String index() {
		OqlBuilder<SessionActivity> query = OqlBuilder.from(SessionActivity.class, "sessionActivity");
		query.where("sessionActivity.name=:name", getLoginName());
		query.orderBy(Order.parse("sessionActivity.loginAt desc"));
		PageLimit limit=getPageLimit();
		limit.setPageSize(10);
		query.limit(limit);
		put("sessionActivities", entityService.search(query));
		put("onlineActivities", sessionController.getOnlineActivities(getUser()));
		return forward();
	}

	public void setSessionController(SessionController sessionController) {
		this.sessionController = sessionController;
	}

}
