//$Id: UserPropertyExporter.java,v 1.1 2007-2-7 下午08:00:39 chaostone Exp $
/*
 *
 * Copyright c 2005-2009
 * Licensed under the Apache License, Version 2.0 (the "License")
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * 
 */
/********************************************************************************
 * @author chaostone
 * 
 * MODIFICATION DESCRIPTION
 * 
 * Name           Date          Description 
 * ============         ============        ============
 *chaostone      2007-2-7         Created
 *  
 ********************************************************************************/

package org.beangle.webapp.security.helper;

import java.util.Collection;

import org.beangle.commons.text.TextResource;
import org.beangle.model.transfer.exporter.DefaultPropertyExtractor;
import org.beangle.security.User;

public class UserPropertyExtractor extends DefaultPropertyExtractor {
	
	public UserPropertyExtractor() {
		super();
	}

	public UserPropertyExtractor(TextResource textResource) {
		super(textResource);
	}

	public Object getPropertyValue(Object target, String property) throws Exception {
		User user = (User) target;
		if ("status".equals(property)) {
			int status = user.getStatus();
			switch (status) {
			case User.ACTIVE:
				return getText("action.activate");
			case User.FREEZE:
				return getText("action.freeze");
			default:
				return "unknown status " + status;
			}
		}
		if ("groups".equals(property)) {
			return getPropertyIn(user.getGroups(), "name");
		} else if ("mngGroups".equals(property)) {
			return getPropertyIn(user.getMngGroups(), "name");
		} else {
			return super.getPropertyValue(target, property);
		}
	}

	public static final StringBuilder getUserNames(Collection<User> users) {
		StringBuilder sb = new StringBuilder();
		for (final User user : users) {
			sb.append(user.getFullname());
			sb.append('(').append(user.getName()).append(')').append(' ');
		}
		if (sb.length() > 0) {
			sb.deleteCharAt(sb.length() - 1);
		}
		return sb;
	}
}
