package org.beangle.webapp.security.view.components;

import java.io.Writer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang.StringUtils;
import org.apache.struts2.components.UIBean;
import org.beangle.security.monitor.Authentication;
import org.beangle.security.monitor.AuthorityManager;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.opensymphony.xwork2.util.ValueStack;

public class Authorize extends UIBean {

	private static final Logger logger = LoggerFactory.getLogger(Authorize.class);

	public Authorize(ValueStack stack, HttpServletRequest req, HttpServletResponse res) {
		super(stack, req, res);
	}

	@Override
	protected String getDefaultTemplate() {
		return "authorize";
	}

	/**
	 * supprt ifAllGranted,ifAnyGranted,ifNotGranted
	 */
	public boolean start(Writer writer) {
		String resource = (String) parameters.get("resource");
		if (StringUtils.isEmpty(resource)) {
			return true;
		} else {
			AuthorityManager authorityManager = (AuthorityManager) stack
					.findValue("authorityManager");
			if (authorityManager.isPublic(resource)) {
				return true;
			} else {
				Long userId = (Long) request.getSession().getAttribute(Authentication.USERID);
				if (null == userId) {
					logger.debug("cannot find {} in session ", Authentication.USERID);
				}
				return authorityManager.isAuthorized(userId, resource);
			}
		}
	}
}
