package org.beangle.webapp.system.action;

import java.io.File;
import java.util.Set;

import org.apache.commons.lang.StringUtils;
import org.beangle.commons.collection.SetUtil;
import org.beangle.struts2.util.MimeTypeProvider;

public class FileMimeType {

	private MimeTypeProvider mimeTypeProvider;

	private Set<String> texts = SetUtil.newHashSet();

	public FileMimeType(MimeTypeProvider mimeTypeProvider) {
		super();
		texts.add("xml");
		this.mimeTypeProvider = mimeTypeProvider;
	}

	public String getMimeType(File file) {
		String ext = StringUtils.substringAfterLast(file.getName(), ".");
		String mimeType = mimeTypeProvider.getMimeType(ext, "application/x-msdownload");
		return StringUtils.replace(mimeType, "/", "-");
	}

	public boolean isTextType(File file) {
		String ext = StringUtils.substringAfterLast(file.getName(), ".");
		String mimeType = mimeTypeProvider.getMimeType(ext, "application/x-msdownload");
		boolean text = mimeType.contains("text");
		if (!text) {
			return texts.contains(ext);
		} else {
			return text;
		}
	}

}
